﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.01
@EndOfDesignText@
#Event: ScrollChanged(X As Float, Y As Float)

#DesignerProperty: Key: BooleanExample, DisplayName: Show Seconds, FieldType: Boolean, DefaultValue: True
#DesignerProperty: Key: Color, DisplayName: Background Color, FieldType: Color, DefaultValue: 0xFFFFFFFF, Description: Background color
'log
Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As B4XView 'ignore
	Private mB As B4XView 'ignore
	Private xui As XUI 'ignore
	
	Public Tag As Object
	Public ScrollingY As Boolean = True
	Public ScrollingX As Boolean = True
	
	Private PanelLocal As B4XView
	Private HorizBar As B4XView
	Private VertBar As B4XView
	
	Private StartX, StartY As Float
	Private FirstX,FirstY As Float
	Private LastY,LastX As Float
	Private FirstTime As Long 
	Private Velocity As Int = 45
	Private HBar As Boolean = True
	Private VBar As Boolean = True
	Private BarSize As Int = 20dip
	Private ClrBar As Int = 0xFFEEEEEE
	Private ClrButtonBar As Int = 0xFFBBBBBB
	Private DurationScroll As Int = 300
	
	Private CanH As B4XCanvas
	Private CanV As B4XCanvas
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	
	#If B4A
		Dim tpc As TouchPanelCreator
		mB=tpc.CreateTouchPanel("Panel")
	#else
		mB=xui.CreatePanel("Panel")
	#End If
	
	PanelLocal=xui.CreatePanel("")
	PanelLocal.SetLayoutAnimated(0,0,0,100dip,100dip)
	HorizBar=xui.CreatePanel("HorizBar")
	VertBar=xui.CreatePanel("VertBar")
End Sub

Public Sub Initialize2 (Callback As Object, EventName As String, PanelParent As B4XView, Width As Int, Height As Int)
	mEventName = EventName
	mCallBack = Callback
	
	If mBase.IsInitialized=False Then mBase=xui.CreatePanel("") Else mBase.RemoveViewFromParent
	PanelParent.AddView(mBase,0,0,Width,Height)
	Tag=mBase.Tag
	mBase.Tag=Me
	
	mB=xui.CreatePanel("Panel")
	mB.SetLayoutAnimated(0,0,0,Width,Height)

	PanelLocal=xui.CreatePanel("")
	PanelLocal.SetLayoutAnimated(0,0,0,Width,Height)
	
	HorizBar=xui.CreatePanel("HorizBar")
	VertBar=xui.CreatePanel("VertBar")
	
	DesignerCreateView(mBase,Null,Null)
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
	Dim clr As Int = xui.PaintOrColorToColor(Props.Get("Color")) 'Example of getting a color value from Props
	mBase.Color=clr
	Tag=mBase.Tag
	mBase.Tag=Me

	mBase.AddView(mB,0,0,mBase.Width,mBase.Height)
	mB.AddView(PanelLocal,0,0,mB.Width,mB.Height)
	mBase.AddView(VertBar,mBase.Width-BarSize,0,BarSize,Max(mBase.Height-BarSize,BarSize))
	mBase.AddView(HorizBar,0,mBase.Height-BarSize,Max(mBase.Height-BarSize,BarSize),BarSize)
	
	CanV.Initialize(VertBar)
	CanH.Initialize(HorizBar)
	
	setHorizontalBar(HBar)
	setVerticalBar(VBar)
	Barre
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	mB.Width=Width
	mB.Height=Height
	setHorizontalBar(HBar)
	setVerticalBar(VBar)
End Sub


Public Sub BringToFront
	mBase.BringToFront
End Sub

Public Sub getPanelWidth As Int
	Return PanelLocal.Width
End Sub

Public Sub setPanelWidth(W As Int)
	PanelLocal.Width=W
	Barre
End Sub

Public Sub getPanelHeight As Int
	Return PanelLocal.Height
End Sub

Public Sub setPanelHeight(H As Int)
	PanelLocal.Height=H
	Barre
End Sub

Public Sub LoadLayout(LayoutFile As String)
	PanelLocal.LoadLayout(LayoutFile)
	
	Dim MaxX As Int = 0
	Dim MaxY As Int = 0
	For Each V As B4XView In PanelLocal.GetAllViewsRecursive
		MaxX=Max(MaxX,V.Left+V.Width)
		MaxY=Max(MaxY,V.Top+V.Height)
	Next
	
	PanelLocal.Width=MaxX
	PanelLocal.Height=MaxY
	Barre
End Sub

Public Sub AddView(View As B4XView, Left As Int, Top As Int, Width As Int, Height As Int)
	PanelLocal.AddView(View,Left,Top,Width,Height)
End Sub

Public Sub GetAllViewsRecursive As List
	Return PanelLocal.GetAllViewsRecursive
End Sub

Public Sub GetView(Index As Int) As B4XView
	Return PanelLocal.GetView(Index)
End Sub

Public Sub setColor(c As Int)
	PanelLocal.Color=c
End Sub

Public Sub getColor As Int
	Return PanelLocal.Color
End Sub

Public Sub NumberOfViews As Int
	Return PanelLocal.NumberOfViews
End Sub

Public Sub RemoveViewFromParent
	mBase.RemoveViewFromParent
End Sub

Public Sub RemoveAllViews
	PanelLocal.RemoveAllViews
End Sub

Public Sub SetBitmap(bmp As B4XBitmap)
	mBase.SetBitmap(bmp)
End Sub

Public Sub SetPanelBitmap(bmp As B4XBitmap)
	PanelLocal.SetBitmap(bmp)
End Sub

Public Sub GetBase As B4XView
	Return mBase
End Sub

Public Sub getPanel As B4XView
	Return PanelLocal
End Sub

Public Sub getHorizontalBar As Boolean
	Return HBar
End Sub

Public Sub setHorizontalBar(B As Boolean)
	HBar=B
	If HBar Then mB.Height=mBase.Height-BarSize Else mB.Height=mBase.Height
	HorizBar.Visible=B
End Sub

Public Sub getVerticalBar As Boolean
	Return VBar
End Sub

Public Sub setVerticalBar(B As Boolean)
	VBar=B
	If VBar Then mB.Width=mBase.Width-BarSize Else mB.Width=mBase.Width
	VertBar.Visible=B
End Sub

Public Sub setFastScroll(B As Boolean)
	If b Then Velocity=60 Else Velocity=45
End Sub

Public Sub getFastScroll As Boolean
	Return (Velocity=20)
End Sub

Public Sub setEnable(B As Boolean)
	mBase.Enabled=B
End Sub

Public Sub getEnable As Boolean
	Return mBase.Enabled
End Sub

Public Sub setLeft(B As Int)
	mBase.Left=B
End Sub

Public Sub getLeft As Int
	Return mBase.Left
End Sub

Public Sub setTop(B As Int)
	mBase.Top=B
End Sub

Public Sub getTop As Int
	Return mBase.top
End Sub

Public Sub setHeight(Height As Int)
	mBase.Height=Height
	Base_Resize(mBase.Height,mBase.Height)
	
	VertBar.SetLayoutAnimated(0,mBase.Width-BarSize,0,BarSize,Max(mBase.Height-BarSize,BarSize))
	HorizBar.SetLayoutAnimated(0,0,mBase.Height-BarSize,Max(mBase.Height-BarSize,BarSize),BarSize)
	Invalidate
End Sub

Public Sub getHeight As Int
	Return mBase.Height
End Sub

Public Sub setWidth(Width As Int)
	mBase.Width=Width
	Base_Resize(mBase.Height,mBase.Height)
	
	VertBar.SetLayoutAnimated(0,mBase.Width-BarSize,0,BarSize,Max(mBase.Height-BarSize,BarSize))
	HorizBar.SetLayoutAnimated(0,0,mBase.Height-BarSize,Max(mBase.Height-BarSize,BarSize),BarSize)
	Invalidate
End Sub

Public Sub getWidth As Int
	Return mBase.Width
End Sub

Public Sub setTag(B As Object)
	mBase.Tag=B
End Sub

Public Sub getTag As Object
	Return mBase.Tag
End Sub

Public Sub setVisible(B As Boolean)
	mBase.Visible=B
End Sub

Public Sub getVisible As Boolean
	Return mBase.Visible
End Sub

Public Sub RequestFocus
	mBase.RequestFocus
End Sub

Public Sub SendToBack
	mBase.SendToBack
End Sub

Public Sub Snapshot As B4XView
	Return mBase.Snapshot
End Sub

Public Sub FullScroll(Bottom As Boolean)
	If Bottom Then
		PanelLocal.Top=Max(PanelLocal.Height-mB.Height,0)
	Else
		PanelLocal.Top=0
	End If
End Sub

Public Sub Invalidate
	Barre
End Sub

Public Sub Parent As B4XView
	Return mBase.Parent
End Sub

Public Sub getPositionX As Float
	Return -PanelLocal.Left
End Sub

Public Sub getPositionY As Float
	Return -PanelLocal.Top
End Sub

Public Sub ScrollPositionX(X As Float)
	If PanelLocal.Width-X<mB.Width Then
		PanelLocal.SetLayoutAnimated(DurationScroll,Min(mB.Width-PanelLocal.Width,0),PanelLocal.Top,PanelLocal.Width,PanelLocal.Height)
	Else
		PanelLocal.SetLayoutAnimated(DurationScroll,-X,PanelLocal.Top,PanelLocal.Width,PanelLocal.Height)
	End If
End Sub

Public Sub ScrollPositionY(Y As Float)
	If PanelLocal.Height-y<mB.Height Then
		PanelLocal.SetLayoutAnimated(DurationScroll,PanelLocal.Left,Min(mB.Width-PanelLocal.Width,0),PanelLocal.Width,PanelLocal.Height)
	Else
		PanelLocal.SetLayoutAnimated(DurationScroll,PanelLocal.Left,-y,PanelLocal.Width,PanelLocal.Height)
	End If
End Sub

Public Sub setPositionX(X As Float)
	If PanelLocal.Width-X<mB.Width Then
		PanelLocal.Left=Min(mB.Width-PanelLocal.Width,0)
	Else
		PanelLocal.Left=-X
	End If
End Sub

Public Sub setPositionY(Y As Float)
	If PanelLocal.Height-y<mB.Height Then
		PanelLocal.top=Min(mB.Width-PanelLocal.Width,0)
	Else
		PanelLocal.top=-y
	End If
End Sub

Public Sub SetColorAndBorder(Backgroundcolor As Int,BorderWidth As Int,BorderColor As Int,BorderCornerRadius As Int)
	mBase.SetColorAndBorder(Backgroundcolor,BorderWidth,BorderColor,BorderCornerRadius)
End Sub

Public Sub SetColorAnimated(Duration As Int, FromColor As Int, ToColor As Int)
	mBase.SetColorAnimated(Duration,FromColor,ToColor)
End Sub

Public Sub SetLayoutAnimated(Duration As Int, Left As Int, Top As Int, Width As Int,Height As Int)
	mBase.SetLayoutAnimated(Duration,Left,Top,Width,Height)
End Sub

Public Sub SetRotationAnimated(Duration As Int, Degree As Int)
	mBase.SetRotationAnimated(Duration,Degree)
End Sub

Public Sub SetVisibleAnimated(Duration As Int, Visible As Boolean)
	mBase.SetVisibleAnimated(Duration,Visible)
End Sub

' ------------------------------------- INTERNAL ---------------------------------------------

#IF B4J
Private Sub Panel_MousePressed (EventData As MouseEvent)
	StartX=PanelLocal.left
	StartY=PanelLocal.Top
	FirstX=EventData.X
	FirstY=EventData.y
	LastX=EventData.X
	LastY=EventData.y
	FirstTime=DateTime.Now
End Sub

Private Sub Panel_MouseDragged (EventData As MouseEvent)
	Dim DeltaX As Float=EventData.X-LastX
	Dim DeltaY As Float=EventData.Y-LastY

	If Abs(LastX-EventData.x)>1 Or Abs(LastY-EventData.Y)>1 Then 
		SpostaY(PanelLocal.Top+DeltaY)
		SpostaX(PanelLocal.Left+DeltaX)	
		Wait For Panel_MouseDragged (EventData As MouseEvent)
		LastX=EventData.X
		LastY=EventData.y
	End If
End Sub

Private Sub Panel_MouseReleased (EventData As MouseEvent)
	Dim DeltaTime As Int = (DateTime.Now-FirstTime)/Velocity
	Dim DeltaX As Float=((EventData.X-FirstX)/DeltaTime)
	Dim DeltaY As Float=((EventData.Y-FirstY)/DeltaTime)
			
	MoveMent(DeltaX,DeltaY,DeltaTime)
End Sub

#ELSE IF B4A

Private Sub Panel_OnInterceptTouchEvent (Action As Int, X As Float, Y As Float, MotionEvent As Object) As Boolean
	Select Action
		Case 0 ' Down
			StartX=PanelLocal.left
			StartY=PanelLocal.Top
			FirstX=X
			FirstY=y
			FirstTime=DateTime.Now
		Case 1 ' UP
			Dim DeltaTime As Int = (DateTime.Now-FirstTime)/Velocity
			Dim DeltaX As Float=((X-FirstX)/DeltaTime)
			Dim DeltaY As Float=((Y-FirstY)/DeltaTime)
			
			MoveMent(DeltaX,DeltaY,DeltaTime)
		Case 2 ' Move
			Dim DeltaX As Float=X-FirstX
			Dim DeltaY As Float=Y-FirstY

			SpostaY(StartY+DeltaY)
			SpostaX(StartX+DeltaX)
		Case 3 ' error
			
	End Select
	
	Return False
End Sub

Private Sub Panel_OnTouchEvent (Action As Int, X As Float, Y As Float, MotionEvent As Object) As Boolean
	Select Action
		Case 0 ' Down
			StartX=PanelLocal.left
			StartY=PanelLocal.Top
			FirstX=X
			FirstY=y
			FirstTime=DateTime.Now
		Case 1 ' UP
			Dim DeltaTime As Int = (DateTime.Now-FirstTime)/Velocity
			Dim DeltaX As Float=((X-FirstX)/DeltaTime)
			Dim DeltaY As Float=((Y-FirstY)/DeltaTime)
			
			MoveMent(DeltaX,DeltaY,DeltaTime)
		Case 2 ' Move
			Dim DeltaX As Float=X-FirstX
			Dim DeltaY As Float=Y-FirstY

			SpostaY(StartY+DeltaY)
			SpostaX(StartX+DeltaX)
		Case 3 ' error
			
	End Select
	
	Return True
End Sub

#ELSE IF B4i
Private Sub Panel_Touch (Action As Int, X As Float, Y As Float)
	Select Action
		Case 0 ' Down
			StartX=PanelLocal.left
			StartY=PanelLocal.Top
			FirstX=X
			FirstY=y
			FirstTime=DateTime.Now
		Case 1 ' UP
			Dim DeltaTime As Int = (DateTime.Now-FirstTime)/Velocity
			Dim DeltaX As Float=((X-FirstX)/DeltaTime)
			Dim DeltaY As Float=((Y-FirstY)/DeltaTime)
			
			MoveMent(DeltaX,DeltaY,DeltaTime)
		Case 2 ' Move
			Dim DeltaX As Float=X-FirstX
			Dim DeltaY As Float=Y-FirstY

			SpostaY(StartY+DeltaY)
			SpostaX(StartX+DeltaX)	
		Case 3 ' error
			
	End Select

End Sub

#END IF

Private Sub HorizBar_Touch (Action As Int, X As Float, Y As Float)
	Select Action
		Case 0 ' Down
			LastX=x
		Case 1 ' UP
			If xui.SubExists(mCallBack,mEventName & "_ScrollChanged",2) Then CallSub3(mCallBack,mEventName & "_ScrollChanged",-PanelLocal.Left,-PanelLocal.Top)
		Case 2 ' Move
			Dim delta As Float = PanelLocal.Width*((x-LastX)/HorizBar.Width)
			SpostaX(PanelLocal.Left-delta)
			LastX=x
		Case 3 ' error
			
	End Select
End Sub

Private Sub VertBar_Touch (Action As Int, X As Float, Y As Float)
	Select Action
		Case 0 ' Down
			LastY=y
		Case 1 ' UP
			If xui.SubExists(mCallBack,mEventName & "_ScrollChanged",2) Then CallSub3(mCallBack,mEventName & "_ScrollChanged",-PanelLocal.Left,-PanelLocal.Top)
		Case 2 ' Move
			Dim delta As Float = PanelLocal.Height*((Y-LastY)/VertBar.Height)
			SpostaY(PanelLocal.top-delta)
			LastY=y		
		Case 3 ' error
			
	End Select
End Sub

Private Sub SpostaX(MoveX As Float)
	If Not(ScrollingX) Then Return
	If PanelLocal.Width>mB.Width Then
		If MoveX>0 Then
			PanelLocal.Left=0
		Else
			PanelLocal.Left=Max(-PanelLocal.Width+mB.Width,MoveX)
		End If
	End If
	Barre
End Sub

Private Sub SpostaY(MoveY As Float)
	If Not(ScrollingY) Then Return
	If PanelLocal.Height>mB.Height Then
		If MoveY>0 Then
			PanelLocal.Top=0
		Else
			PanelLocal.Top=Max(-PanelLocal.Height+mB.Height,MoveY)
		End If
	End If
	Barre
End Sub

Private Sub MoveMent(DX As Float, DY As Float, Dtime As Int)
	If Dtime<6 Then
		For i=1 To Velocity
			SpostaX(PanelLocal.Left+DX)
			SpostaY(PanelLocal.Top+DY)
			DX=DX*0.80
			DY=DY*0.80
			Sleep(10)
		Next
	End If
	
	If xui.SubExists(mCallBack,mEventName & "_ScrollChanged",2) Then CallSub3(mCallBack,mEventName & "_ScrollChanged",-PanelLocal.Left,-PanelLocal.Top)
End Sub

Private Sub Barre
	Dim Rv As Float	= (VertBar.Height/PanelLocal.Height)
	Dim TB As Float = -PanelLocal.top*Rv
	Dim VB As Float = mB.Height*Rv
	Dim RH As Float = (HorizBar.Width/PanelLocal.Width)
	Dim LB As Float = -PanelLocal.Left*RH
	Dim HB As Float = mB.Width*RH
	Dim Rec As B4XRect
	Dim Dist As Int = 1dip
	
	CanH.DrawRect(CanH.TargetRect,ClrBar,True,1)
	Rec.Initialize(LB,Dist,LB+HB,CanH.TargetRect.Height-Dist)
	If HB<10dip Then 
		CanH.DrawRect(Rec,ClrButtonBar,True,1)
	Else
		Dim Path As B4XPath
		Path.InitializeRoundedRect(Rec,5dip)
		CanH.DrawPath(Path,ClrButtonBar,True,1)
	End If
	CanH.Invalidate
	
	CanV.DrawRect(CanV.TargetRect,ClrBar,True,1)
	Rec.Initialize(Dist,TB,CanV.TargetRect.Width-Dist,TB+VB)
	If VB<10dip Then 
		CanV.DrawRect(Rec,ClrButtonBar,True,1)
	Else
		Dim Path As B4XPath
		Path.InitializeRoundedRect(Rec,5dip)
		CanV.DrawPath(Path,ClrButtonBar,True,1)
	End If
	CanV.Invalidate
End Sub
