﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.01
@EndOfDesignText@
#Event: ScrollChangedX (X As Double)
#Event: ScrollChangedY (Y As Double)
#Event: ScrollChanged (X as Double,Y As Double)

''#DesignerProperty: Key: BooleanExample, DisplayName: Show Seconds, FieldType: Boolean, DefaultValue: True
#DesignerProperty: Key: Color, DisplayName: Background Color, FieldType: Color, DefaultValue: 0xFFFFFFFF, Description: Background color
'log
Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As B4XView 'ignore
	Private xui As XUI 'ignore
	
	Public Tag As Object
	
	Private PanelLocal As B4XView
	
	Private HBar As Boolean = True 'ignore
	Private VBar As Boolean = True 'ignore
	
	Private PY As Double = 0
	Private PX As Double = 0
	
	'barre
	#IF B4I
		Private sc As ScrollView
	#ELSE IF B4J
		Private sc As ScrollPane
	#ELSE IF B4a
		Private sc As ScrollView2D
	#END IF
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	
	#If B4i
		sc.Initialize("sc",1000dip,1000dip)
		PanelLocal=sc.Panel
	#ELSE IF B4j
		sc.Initialize("sc")
		sc.Style="-fx-background:transparent;-fx-background-color:transparent;"
		PanelLocal=sc.InnerNode
		sc.Pannable=True
		'mB=sc
	#else IF B4A
		sc.Initialize(1000dip,1000dip,"sc")
		PanelLocal=sc.Panel
	#End If
	mBase=xui.CreatePanel("mBase")
	mBase.SetLayoutAnimated(0,0,0,1dip,1dip)
End Sub

'Create from codice
Public Sub AddToParent(MainPane As B4XView,Left As Int, Top As Int,Width As Int, Height As Int)
	MainPane.AddView(mBase,Left,Top,Width,Height)
	
	#If B4J
	sc.RemoveNodeFromParent
	#ELSE IF B4i
	sc.RemoveViewFromParent
	#ELSE IF B4A
	sc.RemoveView
	#END IF
	
	mBase.Color=xui.Color_Transparent
	mBase.AddView(sc,0,0,Width,Height)
	Tag=mBase.Tag
	mBase.Tag=Me
	
	#IF B4J
		sc.prefWidth=Width
		sc.prefHeight=Height
		PanelLocal.Width=Width-3dip
		PanelLocal.Height=Height-3dip
	#Else
		sc.Width=Width
		sc.Height=Height
	#End If
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
	Dim clr As Int = xui.PaintOrColorToColor(Props.Get("Color")) 'Example of getting a color value from Props
	mBase.Color=clr
	Tag=mBase.Tag
	mBase.Tag=Me
	
	mBase.AddView(sc,0,0,mBase.Width,mBase.Height)
	'sc.Color=xui.Color_Transparent
	'PanelLocal.Color=xui.Color_Transparent
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	mBase.Height=Height
	mBase.Width=Width
	#if B4J
		sc.prefWidth=Width
		sc.prefHeight=Height
	#ELSE
		sc.Width=Width
		sc.Height=Height
	#End If
End Sub


Public Sub BringToFront
	mBase.BringToFront
End Sub

Public Sub IsInitialized As Boolean
	Return mBase.IsInitialized
End Sub

Public Sub getPanelWidth As Int
	#IF B4i
		Return sc.ContentWidth
	#ELSE IF B4J
		Return sc.InnerNode.PrefWidth
	#else IF B4A
		Return PanelLocal.Width
	#End If
End Sub

Public Sub setPanelWidth(W As Int)
	PanelLocal.Width=W
	#IF B4i
		sc.ContentWidth=w
	#ELSE IF B4J
		sc.InnerNode.PrefWidth=w
	#else IF B4A
		sc.Panel.Width=w
	#End If
End Sub

Public Sub getPanelHeight As Int
	#IF B4i
		Return sc.ContentHeight
	#ELSE IF B4J
		Return sc.InnerNode.PrefHeight
	#else IF B4A
		Return PanelLocal.Height
	#End If
End Sub

Public Sub setPanelHeight(H As Int)
	PanelLocal.Height=h
	#IF B4i
		sc.ContentHeight=h
	#ELSE IF B4J
		sc.InnerNode.PrefHeight=h
	#else IF B4A
		sc.Panel.Height=h
	#End If
End Sub

Public Sub LoadLayout(LayoutFile As String)
	PanelLocal.LoadLayout(LayoutFile)
	
	Dim MaxX As Int = 0
	Dim MaxY As Int = 0
	For Each V As B4XView In PanelLocal.GetAllViewsRecursive
		MaxX=Max(MaxX,V.Left+V.Width)
		MaxY=Max(MaxY,V.Top+V.Height)
	Next
	
	PanelLocal.Width=MaxX
	PanelLocal.Height=MaxY
End Sub

Public Sub AddView(View As B4XView, Left As Int, Top As Int, Width As Int, Height As Int)
	PanelLocal.AddView(View,Left,Top,Width,Height)
End Sub

Public Sub GetAllViewsRecursive As List
	Return PanelLocal.GetAllViewsRecursive
End Sub

Public Sub GetView(Index As Int) As B4XView
	Return PanelLocal.GetView(Index)
End Sub

Public Sub setColor(c As Int)
	#IF B4j
	If c=xui.Color_Transparent Then 
		sc.Style="-fx-background:transparent;-fx-background-color:transparent;"
	Else
		sc.Style="-fx-background:#" & ColorToHex(c) & ";-fx-background-color:#" & ColorToHex(c) & ";"
	End If
	#ELSE
		PanelLocal.Color=c
	#END IF
End Sub

Public Sub getColor As Int
	Return PanelLocal.Color
End Sub

Public Sub NumberOfViews As Int
	Return PanelLocal.NumberOfViews
End Sub

Public Sub RemoveViewFromParent
	mBase.RemoveViewFromParent
End Sub

Public Sub RemoveAllViews
	PanelLocal.RemoveAllViews
End Sub

Public Sub SetBitmap(bmp As B4XBitmap)
	mBase.SetBitmap(bmp)
End Sub

Public Sub SetPanelBitmap(bmp As B4XBitmap)
	PanelLocal.SetBitmap(bmp)
End Sub

Public Sub GetBase As B4XView
	Return mBase
End Sub

Public Sub getPanel As B4XView
	Return PanelLocal
End Sub

Public Sub getHorizontalBar As Boolean
	#IF B4I
	Return sc.ShowsHorizontalIndicator
	#Else
	Return HBar
	#End If
End Sub

Public Sub setHorizontalBar(B As Boolean)
	HBar=B
	#IF B4i
		sc.ShowsHorizontalIndicator=B
	#Else if B4A
		Dim r As Reflector
		r.Target = sc
		r.RunMethod2("setHorizontalScrollBarEnabled", B, "java.lang.boolean")
	#else B4J
		If B Then sc.SetHScrollVisibility("AS_NEEDED") Else sc.SetHScrollVisibility("NEVER")
	#End If
End Sub

Public Sub getVerticalBar As Boolean
	#IF B4I
		Return sc.ShowsVerticalIndicator
	#Else
		Return VBar
	#End If
End Sub

Public Sub setVerticalBar(B As Boolean)
	VBar=B
	#IF B4i
		sc.ShowsVerticalIndicator=B
	#Else if B4A
		Dim r As Reflector
   		r.Target = sc
   		r.RunMethod2("setVerticalScrollBarEnabled", False, "java.lang.boolean")		
	#else B4J
	If B Then sc.SetVScrollVisibility("AS_NEEDED") Else sc.SetVScrollVisibility("NEVER")
	#End If	
End Sub

Public Sub setEnable(B As Boolean)
	mBase.Enabled=B
End Sub

Public Sub getEnable As Boolean
	Return mBase.Enabled
End Sub

Public Sub setLeft(B As Int)
	mBase.Left=B
End Sub

Public Sub getLeft As Int
	Return mBase.Left
End Sub

Public Sub setTop(B As Int)
	mBase.Top=B
End Sub

Public Sub getTop As Int
	Return mBase.top
End Sub

Public Sub setHeight(Height As Int)
	Base_Resize(mBase.Width,Height)
	setVerticalBar(VBar)
	setHorizontalBar(HBar)
End Sub

Public Sub getHeight As Int
	Return mBase.Height
End Sub

Public Sub setWidth(Width As Int)
	Base_Resize(Width,mBase.Height)
	setVerticalBar(VBar)
	setHorizontalBar(HBar)
End Sub

Public Sub getWidth As Int
	Return mBase.Width
End Sub

Public Sub setTag(B As Object)
	mBase.Tag=B
End Sub

Public Sub getTag As Object
	Return mBase.Tag
End Sub

Public Sub setVisible(B As Boolean)
	mBase.Visible=B
End Sub

Public Sub getVisible As Boolean
	Return mBase.Visible
End Sub

Public Sub RequestFocus
	mBase.RequestFocus
End Sub

Public Sub SendToBack
	mBase.SendToBack
End Sub

Public Sub Snapshot As B4XView
	Return mBase.Snapshot
End Sub

Public Sub FullScroll(Bottom As Boolean)
	If Bottom Then
		PanelLocal.Top=Max(PanelLocal.Height-sc.Height,0)
	Else
		PanelLocal.Top=0
	End If
End Sub

Public Sub Parent As B4XView
	Return mBase.Parent
End Sub

Public Sub SetColorAndBorder(Backgroundcolor As Int,BorderWidth As Int,BorderColor As Int,BorderCornerRadius As Int)
	mBase.SetColorAndBorder(Backgroundcolor,BorderWidth,BorderColor,BorderCornerRadius)
End Sub

Public Sub SetColorAnimated(Duration As Int, FromColor As Int, ToColor As Int)
	mBase.SetColorAnimated(Duration,FromColor,ToColor)
End Sub

Public Sub SetLayoutAnimated(Duration As Int, Left As Int, Top As Int, Width As Int,Height As Int)
	mBase.SetLayoutAnimated(Duration,Left,Top,Width,Height)
End Sub

Public Sub SetRotationAnimated(Duration As Int, Degree As Int)
	mBase.SetRotationAnimated(Duration,Degree)
End Sub

Public Sub SetVisibleAnimated(Duration As Int, Visible As Boolean)
	mBase.SetVisibleAnimated(Duration,Visible)
End Sub

Public Sub NativeObject As Object
	Return sc
End Sub

#region ScrollChange

Public Sub getPositionX As Double
	Return PX
End Sub

Public Sub getPositionY As Double
	Return PY
End Sub

' X = 0 to 1
Public Sub setPositionX(X As Double)
	PX=x
	#IF B4J
		sc.HPosition=x
	#ELSE IF B4i
		Dim P As Int = x*(sc.Panel.Width-sc.Width)
		sc.ScrollOffsetX=p
	#ELSE IF B4A
		Dim P As Int = x*(sc.Panel.Width-sc.Width)
		sc.HorizontalScrollPosition=p
	#End If
	
End Sub

' Y = 0 to 1
Public Sub setPositionY(Y As Double)
	PY=y
	#IF B4J
		sc.VPosition=Y
	#ELSE IF B4i
		Dim p As Int = Y*(sc.Panel.Height-sc.Height)
		sc.ScrollOffsetY=p
	#ELSE IF B4a
		Dim p As Int = Y*(sc.Panel.Height-sc.Height)
		sc.VerticalScrollPosition=p
	#End If
End Sub

#IF B4J

Private Sub sc_HScrollChanged (Position As Double)
	If Not(Position>=1 And PX>=1) Then 
		PX=Position
		If SubExists(mCallBack,mEventName & "_ScrollChangedX") Then CallSub2(mCallBack,mEventName & "_ScrollChangedX",Position)
	
		If SubExists(mCallBack,mEventName & "_ScrollChanged") Then CallSub3(mCallBack,mEventName & "_ScrollChanged",Position,sc.VPosition)
	End If
End Sub

Private Sub sc_VScrollChanged (Position As Double)
	If Not(Position>=1 And PY>=1) Then
		PY=Position
		If SubExists(mCallBack,mEventName & "_ScrollChangedY") Then CallSub2(mCallBack,mEventName & "_ScrollChangedY",Position)
	
		If SubExists(mCallBack,mEventName & "_ScrollChanged") Then CallSub3(mCallBack,mEventName & "_ScrollChanged",sc.HPosition,Position)
	End If
End Sub

#ELSE IF B4i

Private Sub sc_ScrollChanged (OffsetX As Int, OffsetY As Int)
	PX = OffsetX/(sc.Panel.Width-sc.Width)
	PY = OffsetY/(sc.Panel.Height-sc.Height)
	If SubExists(mCallBack,mEventName & "_ScrollChangedX",1) Then CallSub2(mCallBack,mEventName & "_ScrollChangedX",PX)
	If SubExists(mCallBack,mEventName & "_ScrollChangedY",1) Then CallSub2(mCallBack,mEventName & "_ScrollChangedY",PY)
	
	If SubExists(mCallBack,mEventName & "_ScrollChanged",2) Then CallSub3(mCallBack,mEventName & "_ScrollChanged",PX,PY)
End Sub

#ELSE IF B4A

Private Sub sc_ScrollChanged(PosX As Int, PosY As Int)
	PX = PosX/(sc.Panel.Width-sc.Width)
	PY = PosY/(sc.Panel.Height-sc.Height)
	If SubExists(mCallBack,mEventName & "_ScrollChangedX") Then CallSub2(mCallBack,mEventName & "_ScrollChangedX",PX)
	If SubExists(mCallBack,mEventName & "_ScrollChangedY") Then CallSub2(mCallBack,mEventName & "_ScrollChangedY",PY)
	
	If SubExists(mCallBack,mEventName & "_ScrollChanged") Then CallSub3(mCallBack,mEventName & "_ScrollChanged",PX,PY)
End Sub

#End IF

#End Region

#Region Function

#if B4i

#else if b4a

#else if b4j

Private Sub ColorToHex(clr As Int) As String
	Dim r,g,b,a As Byte
	b=Bit.And(clr,0x000000FF) 'b
	g=Bit.ShiftRight(Bit.And(clr,0x0000FF00),8) 'g 
	r=Bit.ShiftRight(Bit.And(clr,0x00FF0000),16) ' r
	a=Bit.ShiftRight(Bit.And(clr,0xFF000000),24) 'a
	
	
	Return Byte2Hex(r) & Byte2Hex(g) & Byte2Hex(b) & Byte2Hex(a)
End Sub

Sub Byte2Hex(b As Int) As String
	Dim hex As String = "0123456789ABCDEF"
	Dim l,h As Int
	l=Bit.And(b,0xf)
	h=Bit.And(Bit.ShiftRight(b,4),0xf)      ' <- safety fix
	Return (hex.CharAt(h) & hex.CharAt(l))
End Sub
#end if

#End Region